package vip.xiaonuo.hr.modular.write.controller;


import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.github.xiaoymin.knife4j.annotations.ApiSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.pojo.CommonResult;
import vip.xiaonuo.hr.modular.write.entity.HrPeopleWrite;
import vip.xiaonuo.hr.modular.write.service.IHrPeopleWriteService;
import vip.xiaonuo.money.entity.MoneyBusiness;
import vip.xiaonuo.money.entity.vo.MoneyVo;
import vip.xiaonuo.money.param.MoneyParam;

import java.util.Map;

/**
 * <p>
 * 人事月均人数填报 前端控制器
 * </p>
 *
 * @author author
 * @since 2025-05-19
 */
@Api(tags = "人事月均人数填报")
@ApiSupport(author = "wang", order = 1)
@RestController
@Validated
public class HrPeopleWriteController {

    @Autowired
    private IHrPeopleWriteService peopleWriteService;

    @ApiOperation("资金余额填报")
    @PostMapping("/hr/addBalance")
    public CommonResult<JSONArray> addBalance(@RequestBody HrPeopleWrite peopleWrite) {
        String orgId = peopleWrite.getOrgId();
        if (StringUtils.isBlank(orgId)){
            throw new CommonException("请选择公司");
        }
        peopleWriteService.save(peopleWrite);
        return CommonResult.ok();
    }
    @ApiOperationSupport(order = 1)
    @ApiOperation("资金余额列表")
    @PostMapping("/hr/listBalance")
    public CommonResult<Page<HrPeopleWrite>> listBalance(@RequestBody MoneyParam pageParam) {
        return  CommonResult.data(peopleWriteService.listBalance(pageParam));
    }

    @ApiOperationSupport(order = 5)
    @ApiOperation("资金余额删除")
    @PostMapping("/hr/deleteBalance")
    public CommonResult<String> deleteBalance(@RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        peopleWriteService.removeById(id);
        return CommonResult.ok();
    }
    @ApiOperationSupport(order = 4)
    @ApiOperation("资金余额修改")
    @PostMapping("/hr/updateBalance")
    public CommonResult<String> updateBalance(@RequestBody HrPeopleWrite peopleWrite) {
        peopleWriteService.updateById(peopleWrite);
        return CommonResult.ok();
    }
}
